// Wichtig:
// Projekt->Einstellungen->C/C++->Code Generation->Laufzeit-Bibilothek->Multithreaded. 
// Usage: type "http://ip:port/index.html" to show index.html 
// Or: type "http://ip:port/somewhat.html" to show 404 Page with URI
//////////////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <stdio.h>
#include <winsock2.h>
#include <time.h>
#include <stdio.h>
#include <windows.h>
#include <process.h>
#include <stdlib.h>
#include <io.h>
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#define PAGE_BUF	65356
#define SERVER_PORT 6215	//6215
#define MAX_THREADS SOMAXCONN
//#define	OUTPUT_ECHO
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
long WinsockStartup()
{
		long rc;
		WORD wVersionRequested;
		WSADATA wsaData;
		wVersionRequested = MAKEWORD(2, 1); /* Short Wert aus 2 Bytes */
		rc = WSAStartup( wVersionRequested, &wsaData );
		return rc;
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
typedef void *PVOID;
void	client_con(PVOID pvoid);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
int main()
{
	long	rc; 
	SOCKET sockListen;
	SOCKET sockConnected;
	SOCKADDR_IN addr;
	int addrlen = sizeof(addr);

	addr.sin_addr.s_addr = 0;
	addr.sin_family = AF_INET;
	addr.sin_port = htons(SERVER_PORT);

	/* setup winsock */
	rc = WinsockStartup();

	/* create and bind a socket */
	sockListen	=	socket(AF_INET,SOCK_STREAM,NULL);
	if(sockListen==INVALID_SOCKET)
	{
		printf("Fehler: cannot create socked: %d\n",WSAGetLastError());
	}
	else
	{
		printf("Socket created!\n");
	}
	/* bind socket */
	rc=bind(sockListen, (SOCKADDR*)&addr, sizeof(addr));
	if(rc==SOCKET_ERROR)
	{
		printf("Error: socket bind failed: %d\n",WSAGetLastError());
	}
	else
	{
		printf("Socket Port: %i! \n", SERVER_PORT );
	}

	rc=listen(sockListen, SOMAXCONN);
	if(rc==SOCKET_ERROR)
	{
			printf("Error: listen failed: %d\n",WSAGetLastError());
	}
	else
	{
			printf("Listen mode ok!\n");

	}

	/* wait in a loop for incoming connections */
	for( ;; ) 
	{
		
		printf( "========================================================================\n" );
		printf( "Waiting for the nex connection...\n" );
		printf("Request from Client: %s:%d\n",inet_ntoa(addr.sin_addr), ntohs(addr.sin_port) );
		
		sockConnected = accept( sockListen,(SOCKADDR*)&addr, &addrlen);
		if (sockConnected == INVALID_SOCKET)
		{
			printf("Error: Cannot accept connection: %d\n",WSAGetLastError());
		}
		else
		{
			PVOID pvoidv = NULL;
			/* start thread  */
			_beginthread(client_con, 0, (void*)&sockConnected);
		}
		
	}

	_endthread();
	return EXIT_SUCCESS;
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
void client_con(PVOID pvoid)
{
	long	rc; 
	int i=0, ianf=0, iend=0;
	char timestr[80];
	char hostname[200];
	char *siteheader, *page_404, *recvBuf, *output_stream, *end, *anf, *uri;
 	
	siteheader	=	new char[1024];
	page_404	=	new char[1024];
	recvBuf		=	new char[PAGE_BUF+1];
	FILE *stream;
	output_stream=	new char[1024];

	SOCKET sockConnected= *(int*)pvoid;
	printf("sockConnected: %i\n", sockConnected);

	// Server HTTP-Header
	//

	time_t now;
	struct tm *tm;
	now = time(0);
	tm = gmtime(&now);
	strftime(timestr, sizeof timestr, "%a, %d %b %Y %H:%M:%S GMT", tm);

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	sprintf(siteheader,"HTTP/1.1 200 OK\n"
		    "Date: %s\n"
		    "Server: HTTP Server by Artur Funk Server/1.0.0\n"
		    "Location: localhost \n"
			"Keep-Alive: timeout=15, max=100\n"
		    "Content-Type: text/html; charset=ISO-8859-1\n"
		    "\n",  timestr);
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		rc = recv(sockConnected,recvBuf,PAGE_BUF,NULL);
		if (rc == SOCKET_ERROR)
		{
			  printf("Error: Cannot recive data\n",WSAGetLastError());
		}
		recvBuf[rc] = '\0';
		printf("Recived: \n\n%s", recvBuf);
	
		/* is a little bit komisch but works very naaaaiiss */
		/////////////////////////////////////////////////////////////////////////////////////
		
        anf = strstr (recvBuf,"GET /");
        end = strstr (recvBuf,"HTTP/1.1");

		int recv_start_pos = (int)anf-(int)recvBuf+5;
		int recv_end_pos  = (int)end-(int)recvBuf;
		int length = recv_end_pos - recv_start_pos+ 1;
		uri = new char[length];
		for (i=recv_start_pos; i<recv_end_pos; i++) uri[i-recv_start_pos] = recvBuf[i];
		uri[length-1] = '\0';
		if(strlen(uri)<2)
		{
			uri="index.html";
		}
		printf("URI %s\n", uri);

		/* Get own hostname */
		gethostname( hostname, sizeof(hostname));
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		sprintf(page_404,
		"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">\n"
		"<HTML><HEAD>\n"
		"<TITLE>Error: 404</TITLE>\n"
		"</HEAD><BODY>\n"
		"<H1>404 File not found:</H1>\n"	
		"http://%s/%s<BR>\n"
		"<hr>%s<BR><hr>\n"
		"</BODY></HTML>\n", hostname,uri, timestr);

		////////////////////////////////////////////////////////////////////////////////////
		rc = send(sockConnected,siteheader, strlen(siteheader) + 1, NULL);
		if (rc == SOCKET_ERROR)
		{
			  printf("Error: Cannot send data\n",WSAGetLastError());
		}
		
		if ((stream = fopen(uri, "r")) == NULL)
		 {
			rc = send(sockConnected,page_404, strlen(page_404), NULL);
			printf("Error: cannot open the given file\n");
		 }
		 else
		 {	
	   		
			while (!feof(stream))
			{
				fgets(output_stream,1024,stream);
				#if defined(OUTPUT_ECHO)
					printf("%s\n",output_stream);
				#endif
				rc = send( sockConnected,output_stream, strlen(output_stream), NULL);
			}
				
			fclose(stream);
			//Sleep(1000);
		  }


		printf("Send data to client: ok\n");

		/* Windows Socket beenden */
		shutdown( sockConnected, SD_SEND );
		closesocket( sockConnected );	
		_endthread();

		delete[] siteheader;
		delete[] page_404; 
		delete[] recvBuf; 
		delete[] output_stream;
		delete[] end; 
		delete[] anf; 
		delete[] uri;
}